package cofh.thermal.expansion.inventory.container.machine;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cofh.core.inventory.container.TileContainer;
import cofh.core.network.packet.server.TileConfigPacket;
import cofh.lib.api.block.entity.IPacketHandlerTile;
import cofh.lib.inventory.container.slot.SlotCoFH;
import cofh.lib.inventory.container.slot.SlotFalseCopy;
import cofh.lib.inventory.container.slot.SlotRemoveOnly;
import cofh.lib.inventory.wrapper.InvWrapperCoFH;
import cofh.lib.util.Utils;
import cofh.thermal.expansion.block.entity.machine.MachineCrafterTile;
import cofh.thermal.expansion.init.TExpContainers;
import java.util.Optional;
import net.minecraft.core.BlockPos;
import net.minecraft.network.protocol.Packet;
import net.minecraft.network.protocol.game.ClientboundContainerSetSlotPacket;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.CraftingContainer;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.ResultContainer;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.crafting.CraftingRecipe;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.level.Level;

public class MachineCrafterContainer extends TileContainer {
  public final MachineCrafterTile tile;
  
  private final CraftingContainer craftMatrix = new CraftingContainer((AbstractContainerMenu)this, 3, 3);
  
  private final ResultContainer craftResult = new ResultContainer();
  
  private final Player player;
  
  private final boolean initialized;
  
  public MachineCrafterContainer(int windowId, Level level, BlockPos pos, Inventory inventory, Player player) {
    super((MenuType)TExpContainers.MACHINE_CRAFTER_CONTAINER.get(), windowId, level, pos, inventory, player);
    this.tile = (MachineCrafterTile)level.m_7702_(pos);
    InvWrapperCoFH tileInv = new InvWrapperCoFH(this.tile.getItemInv());
    this.player = inventory.f_35978_;
    int i;
    for (i = 0; i < 9; i++)
      m_38897_((Slot)new SlotCoFH(tileInv, i, 8 + i * 18, 77)); 
    m_38897_((Slot)new SlotRemoveOnly((Container)tileInv, 9, 143, 21));
    m_38897_((Slot)new SlotCoFH(tileInv, 10, 8, 53));
    for (i = 0; i < 3; i++) {
      for (int j = 0; j < 3; j++)
        m_38897_((Slot)new SlotFalseCopy((Container)this.craftMatrix, j + i * 3, 53 + j * 18, 17 + i * 18)); 
    } 
    m_38897_((Slot)new Object(this, player, this.craftMatrix, (Container)this.craftResult, 0, 114, 44));
    bindAugmentSlots((Container)tileInv, 21, this.tile.augSize());
    bindPlayerInventory(inventory);
    if (Utils.isServerWorld(level)) {
      for (i = 0; i < 9; i++)
        this.craftMatrix.m_6836_(i, this.tile.getItemInv().get(11 + i)); 
      calcCraftingGrid();
    } 
    this.initialized = true;
  }
  
  protected int getPlayerInventoryVerticalOffset() {
    return 108;
  }
  
  public void m_6877_(Player playerIn) {
    super.m_6877_(playerIn);
    this.tile.clearRecipeChanges();
  }
  
  public void m_6199_(Container inventoryIn) {
    super.m_6199_(inventoryIn);
    slotChangedCraftingGrid();
  }
  
  public boolean hasValidRecipe() {
    return !this.craftResult.m_8020_(0).m_41619_();
  }
  
  public void setRecipe() {
    for (int i = 0; i < this.craftMatrix.m_6643_(); i++)
      this.tile.getItemInv().set(11 + i, this.craftMatrix.m_8020_(i)); 
    TileConfigPacket.sendToServer((IPacketHandlerTile)this.tile);
    this.tile.clearRecipeChanges();
  }
  
  protected void slotChangedCraftingGrid() {
    if (this.syncing || !this.initialized)
      return; 
    Level level = this.tile.m_58904_();
    if (Utils.isServerWorld(level)) {
      ServerPlayer playerMP = (ServerPlayer)this.player;
      ItemStack stack = ItemStack.f_41583_;
      Optional<CraftingRecipe> possibleRecipe = level.m_7465_().m_44015_(RecipeType.f_44107_, (Container)this.craftMatrix, level);
      if (possibleRecipe.isPresent()) {
        stack = ((CraftingRecipe)possibleRecipe.get()).m_5874_((Container)this.craftMatrix);
        this.craftResult.m_6029_(this.craftResult.m_7928_());
      } 
      this.tile.markRecipeChanges();
      this.craftResult.m_6836_(0, stack);
      playerMP.f_8906_.m_141995_((Packet)new ClientboundContainerSetSlotPacket(this.f_38840_, m_182425_(), 20, stack));
    } else {
      calcCraftingGrid();
      this.tile.markRecipeChanges();
    } 
  }
  
  protected void calcCraftingGrid() {
    Level level = this.tile.m_58904_();
    ItemStack stack = ItemStack.f_41583_;
    if (level != null) {
      Optional<CraftingRecipe> possibleRecipe = level.m_7465_().m_44015_(RecipeType.f_44107_, (Container)this.craftMatrix, level);
      if (possibleRecipe.isPresent()) {
        this.craftResult.m_6029_((Recipe)possibleRecipe.get());
        stack = ((CraftingRecipe)possibleRecipe.get()).m_5874_((Container)this.craftMatrix);
      } 
    } 
    this.craftResult.m_6836_(0, stack);
  }
}
